diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/mpi-test-fixtures.h ns-3.33/src/mpi/examples/mpi-test-fixtures.h
--- ns-3.32/src/mpi/examples/mpi-test-fixtures.h	1969-12-31 16:00:00.000000000 -0800
+++ ns-3.33/src/mpi/examples/mpi-test-fixtures.h	2021-01-09 10:19:22.000000000 -0800
@@ -0,0 +1,143 @@
+/* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
+/*
+ *  Copyright 2018. Lawrence Livermore National Security, LLC.
+ *
+ * This program is free software; you can redistribute it and/or modify
+ * it under the terms of the GNU General Public License version 2 as
+ * published by the Free Software Foundation;
+ *
+ * This program is distributed in the hope that it will be useful,
+ * but WITHOUT ANY WARRANTY; without even the implied warranty of
+ * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
+ * GNU General Public License for more details.
+ *
+ * You should have received a copy of the GNU General Public License
+ * along with this program; if not, write to the Free Software
+ * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
+ *
+ * Author: Steven Smith <smith84@llnl.gov>
+ */
+
+#include <iomanip>
+#include <sstream>
+#include <ios>
+
+/**
+ * \file
+ * \ingroup mpi
+ *
+ * Common methods for MPI examples. 
+ *
+ * Since MPI output is coming from multiple processors it is the
+ * ordering between the processors is non-deterministic.  For
+ * regression testing the output is sorted to force a deterministic
+ * ordering. Methods include here add line number to support 
+ * this sorting.
+ *
+ * Testing output is also grepped so only lines with "TEST" are
+ * included.  Some MPI launchers emit extra text to output which must
+ * be excluded for regression comparisons.
+ */
+
+namespace ns3 {
+
+template <typename T> class Ptr;
+class Address;
+class Packet;
+
+  
+/**
+ * Write to std::cout only from rank 0.
+ * Number line for sorting output of parallel runs.
+ *
+ * \param x The output operators.
+ */
+#define RANK0COUT(x)                                                                   \
+  do                                                                                   \
+    if (SinkTracer::GetWorldRank () == 0)                                              \
+      {                                                                                \
+        std::cout << "TEST : ";                                                        \
+        std::ios_base::fmtflags f( std::cout.flags() );                                \
+        std::cout << std::setfill('0') << std::setw(5) << SinkTracer::GetLineCount (); \
+        std::cout.flags( f );                                                          \
+        std::cout << " : " << x;                                                       \
+      }                                                                                \
+  while (false)
+  
+#define RANK0COUTAPPEND(x)                      \
+  do                                            \
+    if (SinkTracer::GetWorldRank () == 0)       \
+      {                                         \
+        std::cout << x ;                        \
+      }                                         \
+  while (false)
+
+class SinkTracer
+{
+
+public:
+  /**
+   * PacketSink receive trace callback.
+   * \copydetails ns3::Packet::TwoAddressTracedCallback
+   */
+  static void Init (void);
+
+  /**
+   * PacketSink receive trace callback.
+   * \copydetails ns3::Packet::TwoAddressTracedCallback
+   */
+  static void SinkTrace (const ns3::Ptr<const ns3::Packet> packet,
+                         const ns3::Address &srcAddress,
+                         const ns3::Address &destAddress);
+
+  /**
+   * Verify the sink trace count observed matches the expected count.
+   * Prints message to std::cout indicating success or fail.
+   */
+  static void Verify (unsigned long expectedCount);
+  
+  /**
+   * Get the source address and port, as a formatted string.
+   *
+   * \param [in] address The ns3::Address.
+   * \return A string with the formatted address and port number.
+   */
+  static std::string FormatAddress (const ns3::Address address);
+
+  /**
+   * Get the MPI rank in the world communicator.
+   *
+   * \return MPI world rank.
+   */
+  static int GetWorldRank (void)
+  {
+    return m_worldRank;
+  }
+
+  /**
+   * Get the MPI size of the world communicator.
+   *
+   * \return MPI world size.
+   */
+  static int GetWorldSize (void)
+  {
+    return m_worldSize;
+  }
+
+  /**
+   * Get current line count and increment.
+   *
+   */
+  static int GetLineCount (void)
+  {
+    return m_line++;
+  }
+
+private:
+  static unsigned long m_sinkCount; /*< Running sum of number of SinkTrace calls observed */
+  static unsigned long m_line; /*< Current output line number for ordering output */
+  static int m_worldRank; /*< MPI CommWorld rank */
+  static int m_worldSize; /*< MPI CommWorld size */
+};
+
+}  // namespace ns3
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/nms-p2p-nix-distributed.cc ns-3.33/src/mpi/examples/nms-p2p-nix-distributed.cc
--- ns-3.32/src/mpi/examples/nms-p2p-nix-distributed.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/examples/nms-p2p-nix-distributed.cc	2021-01-09 10:19:22.000000000 -0800
@@ -14,6 +14,11 @@
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
  * (c) 2009, GTech Systems, Inc. - Alfred Park <park@gtech-systems.com>
+ */
+
+/**
+ * \file
+ * \ingroup mpi
  *
  * DARPA NMS Campus Network Model
  *
@@ -33,11 +38,7 @@
  * to make very large simulations.
  */
 
-// for timing functions
-#include <cstdlib>
-#include <sys/time.h>
-#include <fstream>
-#include <vector>
+#include "mpi-test-fixtures.h"
 
 #include "ns3/core-module.h"
 #include "ns3/internet-module.h"
@@ -48,12 +49,10 @@
 #include "ns3/mpi-interface.h"
 #include "ns3/ipv4-nix-vector-helper.h"
 
-using namespace ns3;
+#include <fstream>
+#include <vector>
 
-typedef struct timeval TIMER_TYPE;
-#define TIMER_NOW(_t) gettimeofday (&_t,NULL);
-#define TIMER_SECONDS(_t) ((double)(_t).tv_sec + (_t).tv_usec * 1e-6)
-#define TIMER_DIFF(_t1, _t2) (TIMER_SECONDS (_t1) - TIMER_SECONDS (_t2))
+using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("CampusNetworkModelDistributed");
 
@@ -67,66 +66,78 @@
   typedef std::vector<Ipv4InterfaceContainer> vectorOfIpv4InterfaceContainer;
   typedef std::vector<vectorOfIpv4InterfaceContainer> vectorOfVectorOfIpv4InterfaceContainer;
   typedef std::vector<vectorOfVectorOfIpv4InterfaceContainer> vectorOfVectorOfVectorOfIpv4InterfaceContainer;
- 
+
   typedef std::vector<NetDeviceContainer> vectorOfNetDeviceContainer;
   typedef std::vector<vectorOfNetDeviceContainer> vectorOfVectorOfNetDeviceContainer;
 
   // Enable parallel simulator with the command line arguments
   MpiInterface::Enable (&argc, &argv);
 
-  TIMER_TYPE t0, t1, t2;
-  TIMER_NOW (t0);
-  std::cout << " ==== DARPA NMS CAMPUS NETWORK SIMULATION ====" << std::endl;
+  SinkTracer::Init ();
 
-  GlobalValue::Bind ("SimulatorImplementationType",
-                     StringValue ("ns3::DistributedSimulatorImpl"));
+  SystemWallClockMs t0;  // Total time
+  SystemWallClockMs t1;  // Setup time
+  SystemWallClockMs t2;  // Run time/
+  t0.Start ();
+  t1.Start ();
 
   uint32_t systemId = MpiInterface::GetSystemId ();
   uint32_t systemCount = MpiInterface::GetSize ();
 
-  uint32_t nCN = 2, nLANClients = 42;
-  int32_t single = 0;
-  int nBytes = 500000; // Bytes for each on/off app
+  RANK0COUT (" ==== DARPA NMS CAMPUS NETWORK SIMULATION ====" << std::endl);
+
+  GlobalValue::Bind ("SimulatorImplementationType",
+                     StringValue ("ns3::DistributedSimulatorImpl"));
+
+  uint32_t nCN = 2;
+  uint32_t nLANClients = 10;
+  bool single = 0;
+  int nPackets = 10; // Packets sent by OnOff applications
   bool nix = true;
+  Time stop = Seconds (100);
+  bool verbose = false;
+  bool testing = false;
 
   CommandLine cmd (__FILE__);
-  cmd.AddValue ("CN", "Number of total CNs [2]", nCN);
-  cmd.AddValue ("LAN", "Number of nodes per LAN [42]", nLANClients);
-  cmd.AddValue ("single", "1 if use single flow", single);
-  cmd.AddValue ("nBytes", "Number of bytes for each on/off app", nBytes);
+  cmd.AddValue ("campuses", "Number of campus networks", nCN);
+  cmd.AddValue ("clients", "Number of client nodes per LAN", nLANClients);
+  cmd.AddValue ("packets", "Number of packets each on/off app should send", nPackets);
   cmd.AddValue ("nix", "Toggle the use of nix-vector or global routing", nix);
+  cmd.AddValue ("stop", "Simulation run time", stop);
+  cmd.AddValue ("single", "Use single on/off app per campus network", single);
+  cmd.AddValue ("verbose", "Show extra timing information", verbose);
+  cmd.AddValue ("test", "Enable regression test output", testing);
+  
   cmd.Parse (argc,argv);
 
   if (nCN < 2)
     {
-      std::cout << "Number of total CNs (" << nCN << ") lower than minimum of 2"
-           << std::endl;
+      RANK0COUT ("Number of total CNs (" << nCN << ") lower than minimum of 2"
+              << std::endl);
       return 1;
     }
   if (systemCount > nCN)
     {
-      std::cout << "Number of total CNs (" << nCN << ") should be >= systemCount ("
-           << systemCount << ")." << std::endl;
+      RANK0COUT ("Number of total CNs (" << nCN << ") should be >= systemCount ("
+               << systemCount << ")." << std::endl);
       return 1;
     }
 
-  std::cout << "Number of CNs: " << nCN << ", LAN nodes: " << nLANClients << std::endl;
-  
-
+  RANK0COUT ("Number of CNs: " << nCN << ", LAN nodes: " << nLANClients << std::endl);
 
   vectorOfNodeContainer nodes_netLR(nCN);
   vectorOfVectorOfNodeContainer nodes_net0(nCN,vectorOfNodeContainer(3));
   vectorOfVectorOfNodeContainer nodes_net1(nCN,vectorOfNodeContainer(6));
   vectorOfVectorOfNodeContainer nodes_net2(nCN,vectorOfNodeContainer(14));
   vectorOfVectorOfNodeContainer nodes_net3(nCN,vectorOfNodeContainer(9));
-     
+
   vectorOfVectorOfVectorOfNodeContainer nodes_net2LAN(nCN,vectorOfVectorOfNodeContainer(7,vectorOfNodeContainer(nLANClients)));
   vectorOfVectorOfVectorOfNodeContainer nodes_net3LAN(nCN,vectorOfVectorOfNodeContainer(5,vectorOfNodeContainer(nLANClients)));
-  
+
   PointToPointHelper p2p_2gb200ms, p2p_1gb5ms, p2p_100mb1ms;
   InternetStackHelper stack;
-  
-  Ipv4InterfaceContainer ifs;  
+
+  Ipv4InterfaceContainer ifs;
 
   vectorOfVectorOfIpv4InterfaceContainer ifs0(nCN,vectorOfIpv4InterfaceContainer(3));
   vectorOfVectorOfIpv4InterfaceContainer ifs1(nCN,vectorOfIpv4InterfaceContainer(6));
@@ -134,7 +145,7 @@
   vectorOfVectorOfIpv4InterfaceContainer ifs3(nCN,vectorOfIpv4InterfaceContainer(9));
   vectorOfVectorOfVectorOfIpv4InterfaceContainer ifs2LAN(nCN,vectorOfVectorOfIpv4InterfaceContainer(7,vectorOfIpv4InterfaceContainer(nLANClients)));
   vectorOfVectorOfVectorOfIpv4InterfaceContainer ifs3LAN(nCN,vectorOfVectorOfIpv4InterfaceContainer(5,vectorOfIpv4InterfaceContainer(nLANClients)));
-  
+
   Ipv4AddressHelper address;
   std::ostringstream oss;
   p2p_1gb5ms.SetDeviceAttribute ("DataRate", StringValue ("1Gbps"));
@@ -153,9 +164,9 @@
   // Create Campus Networks
   for (uint32_t z = 0; z < nCN; ++z)
     {
-      std::cout << "Creating Campus Network " << z << ":" << std::endl;
+      RANK0COUT ("Creating Campus Network " << z << ":" << std::endl);
       // Create Net0
-      std::cout << "  SubNet [ 0";
+      RANK0COUT ("  SubNet [ 0");
       for (int i = 0; i < 3; ++i)
         {
           Ptr<Node> node = CreateObject<Node> (z % systemCount);
@@ -171,7 +182,7 @@
           ndc0[i] = p2p_1gb5ms.Install (nodes_net0[z][i]);
         }
       // Create Net1
-      std::cout << " 1";
+      RANK0COUTAPPEND (" 1");
       for (int i = 0; i < 6; ++i)
         {
           Ptr<Node> node = CreateObject<Node> (z % systemCount);
@@ -203,7 +214,7 @@
       address.SetBase (oss.str ().c_str (), "255.255.255.0");
       ifs = address.Assign (ndc0_1);
       // Create Net2
-      std::cout << " 2";
+      RANK0COUTAPPEND (" 2");
       for (int i = 0; i < 14; ++i)
         {
           Ptr<Node> node = CreateObject<Node> (z % systemCount);
@@ -246,7 +257,7 @@
             }
         }
       // Create Net3
-      std::cout << " 3 ]" << std::endl;
+      RANK0COUTAPPEND (" 3 ]" << std::endl);
       for (int i = 0; i < 9; ++i)
         {
           Ptr<Node> node = CreateObject<Node> (z % systemCount);
@@ -283,7 +294,7 @@
               ifs3LAN[z][i][j] = address.Assign (ndc3LAN[i][j]);
             }
         }
-      std::cout << "  Connecting Subnets..." << std::endl;
+      RANK0COUT ("  Connecting Subnets..." << std::endl);
       // Create Lone Routers (Node 4 & 5)
       Ptr<Node> node1 = CreateObject<Node> (z % systemCount);
       Ptr<Node> node2 = CreateObject<Node> (z % systemCount);
@@ -338,7 +349,7 @@
       address.SetBase (oss.str ().c_str (), "255.255.255.0");
       ifs = address.Assign (ndc3_5b);
       // Assign IP addresses
-      std::cout << "  Assigning IP addresses..." << std::endl;
+      RANK0COUT ("  Assigning IP addresses..." << std::endl);
       for (int i = 0; i < 3; ++i)
         {
           oss.str ("");
@@ -379,7 +390,7 @@
   // Create Ring Links
   if (nCN > 1)
     {
-      std::cout << "Forming Ring Topology..." << std::endl;
+      RANK0COUT ("Forming Ring Topology..." << std::endl);
       vectorOfNodeContainer nodes_ring(nCN);
       for (uint32_t z = 0; z < nCN - 1; ++z)
         {
@@ -400,9 +411,9 @@
     }
 
   // Create Traffic Flows
-  std::cout << "Creating UDP Traffic Flows:" << std::endl;
+  RANK0COUT ("Creating UDP Traffic Flows:" << std::endl);
   Config::SetDefault ("ns3::OnOffApplication::MaxBytes",
-                      UintegerValue (nBytes));
+                      UintegerValue (nPackets * 512));
   Config::SetDefault ("ns3::OnOffApplication::OnTime",
                       StringValue ("ns3::ConstantRandomVariable[Constant=1]"));
   Config::SetDefault ("ns3::OnOffApplication::OffTime",
@@ -418,10 +429,14 @@
                                                           9999));
           ApplicationContainer sinkApp = sinkHelper.Install (nodes_net1[0][2].Get (0));
           sinkApp.Start (Seconds (0.0));
+          if (testing)
+            {
+              sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+            }
 
           OnOffHelper client ("ns3::UdpSocketFactory", Address ());
           AddressValue remoteAddress (InetSocketAddress (ifs1[0][2].GetAddress (0), 9999));
-          std::cout << "Remote Address is " << ifs1[0][2].GetAddress (0) << std::endl;
+          RANK0COUT ("Remote Address is " << ifs1[0][2].GetAddress (0) << std::endl);
           client.SetAttribute ("Remote", remoteAddress);
 
           ApplicationContainer clientApp;
@@ -435,8 +450,11 @@
                                                           9999));
           ApplicationContainer sinkApp =
             sinkHelper.Install (nodes_net1[1][0].Get (0));
-
           sinkApp.Start (Seconds (0.0));
+          if (testing)
+            {
+              sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+            }
         }
       else if (systemId == 0)
         {
@@ -444,7 +462,7 @@
           AddressValue remoteAddress
             (InetSocketAddress (ifs1[1][0].GetAddress (0), 9999));
 
-          std::cout << "Remote Address is " << ifs1[1][0].GetAddress (0) << std::endl;
+          RANK0COUT ("Remote Address is " << ifs1[1][0].GetAddress (0) << std::endl);
           client.SetAttribute ("Remote", remoteAddress);
 
           ApplicationContainer clientApp;
@@ -465,7 +483,7 @@
               x = 0;
             }
           // Subnet 2 LANs
-          std::cout << "  Campus Network " << z << " Flows [ Net2 ";
+          RANK0COUT ("  Campus Network " << z << " Flows [ Net2 ");
           for (int i = 0; i < 7; ++i)
             {
               for (uint32_t j = 0; j < nLANClients; ++j)
@@ -481,6 +499,10 @@
                         sinkHelper.Install (nodes_net2LAN[z][i][j].Get (0));
 
                       sinkApp.Start (Seconds (0.0));
+                      if (testing)
+                        {
+                          sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+                        }
                     }
                   else if (systemId == z % systemCount)
                     {
@@ -492,6 +514,10 @@
                         sinkHelper.Install (nodes_net2LAN[z][i][j].Get (0));
 
                       sinkApp.Start (Seconds (0.0));
+                      if (testing)
+                        {
+                          sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+                        }
                     }
                   // Sources
                   if (systemCount == 1)
@@ -525,7 +551,7 @@
                 }
             }
           // Subnet 3 LANs
-          std::cout << "Net3 ]" << std::endl;
+          RANK0COUTAPPEND ("Net3 ]" << std::endl);
           for (int i = 0; i < 5; ++i)
             {
               for (uint32_t j = 0; j < nLANClients; ++j)
@@ -539,8 +565,11 @@
 
                       ApplicationContainer sinkApp =
                         sinkHelper.Install (nodes_net3LAN[z][i][j].Get (0));
-
                       sinkApp.Start (Seconds (0.0));
+                      if (testing)
+                        {
+                          sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+                        }
                     }
                   else if (systemId == z % systemCount)
                     {
@@ -552,6 +581,10 @@
                         sinkHelper.Install (nodes_net3LAN[z][i][j].Get (0));
 
                       sinkApp.Start (Seconds (0.0));
+                      if (testing)
+                        {
+                          sinkApp.Get (0)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+                        }
                     }
                   // Sources
                   if (systemCount == 1)
@@ -587,40 +620,57 @@
         }
     }
 
-  std::cout << "Created " << NodeList::GetNNodes () << " nodes." << std::endl;
-  TIMER_TYPE routingStart;
-  TIMER_NOW (routingStart);
+  RANK0COUT ("Created " << NodeList::GetNNodes () << " nodes." << std::endl);
+  SystemWallClockMs tRouting;
+  tRouting.Start ();;
 
   if (nix)
     {
-      std::cout << "Using Nix-vectors..." << std::endl;
+      RANK0COUT ("Using Nix-vectors..." << std::endl);
     }
   else
     {
       // Calculate routing tables
-      std::cout << "Populating Routing tables..." << std::endl;
+      RANK0COUT ("Populating Routing tables..." << std::endl);
       Ipv4GlobalRoutingHelper::PopulateRoutingTables ();
     }
 
-  TIMER_TYPE routingEnd;
-  TIMER_NOW (routingEnd);
-  std::cout << "Routing tables population took "
-       << TIMER_DIFF (routingEnd, routingStart) << std::endl;
-
-  std::cout << "Running simulator..." << std::endl;
-  TIMER_NOW (t1);
-  Simulator::Stop (Seconds (100.0));
+  tRouting.End ();
+  if (verbose)
+    {
+      RANK0COUT ("Routing tables population took "
+                 << tRouting.GetElapsedReal () << "ms" << std::endl);
+    }
+
+  RANK0COUT ("Running simulator..." << std::endl);
+  t1.End ();
+  t2.Start ();
+  Simulator::Stop (stop);
   Simulator::Run ();
-  TIMER_NOW (t2);
-  std::cout << "Simulator finished." << std::endl;
+  RANK0COUT ("Simulator finished." << std::endl);
   Simulator::Destroy ();
+
+  if (testing)
+    {
+      const int numberNodesSending = nCN * ( nLANClients * (7 + 5)); // 7 size of Net2, 5 size of Net3
+      const int expectedPacketCount = numberNodesSending * nPackets;
+
+      SinkTracer::Verify (expectedPacketCount);
+    }
+  
   // Exit the parallel execution environment
   MpiInterface::Disable ();
-  double d1 = TIMER_DIFF (t1, t0), d2 = TIMER_DIFF (t2, t1);
-  std::cout << "-----" << std::endl << "Runtime Stats:" << std::endl;
-  std::cout << "Simulator init time: " << d1 << std::endl;
-  std::cout << "Simulator run time: " << d2 << std::endl;
-  std::cout << "Total elapsed time: " << d1 + d2 << std::endl;
+  t2.End ();
+  RANK0COUT ("-----" << std::endl);
+
+  if (verbose)
+    {
+      RANK0COUT ("Runtime Stats:\n"
+                << "Simulator init time: " << t1.GetElapsedReal () << "ms\n"
+                << "Simulator run time:  " << t2.GetElapsedReal () << "ms\n"
+                << "Total elapsed time:  " << t0.GetElapsedReal () << "ms"
+                 << std::endl);
+    }
   return 0;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/simple-distributed.cc ns-3.33/src/mpi/examples/simple-distributed.cc
--- ns-3.32/src/mpi/examples/simple-distributed.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/examples/simple-distributed.cc	2021-01-09 10:19:22.000000000 -0800
@@ -12,7 +12,11 @@
  * You should have received a copy of the GNU General Public License
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
- *
+ */
+
+/**
+ * \file
+ * \ingroup mpi
  *
  * TestDistributed creates a dumbbell topology and logically splits it in
  * half.  The left half is placed on logical processor 0 and the right half
@@ -41,6 +45,8 @@
  * right leaf nodes output logging information when they receive the packet.
  */
 
+#include "mpi-test-fixtures.h"
+
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include "ns3/mpi-interface.h"
@@ -53,6 +59,8 @@
 #include "ns3/packet-sink-helper.h"
 #include <mpi.h>
 
+#include <iomanip>
+
 using namespace ns3;
 
 NS_LOG_COMPONENT_DEFINE ("SimpleDistributed");
@@ -63,12 +71,16 @@
   bool nix = true;
   bool nullmsg = false;
   bool tracing = false;
+  bool testing = false;
+  bool verbose = false;
 
   // Parse command line
   CommandLine cmd (__FILE__);
   cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization", nullmsg);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
+  cmd.AddValue ("verbose", "verbose output", verbose);
+  cmd.AddValue ("test", "Enable regression test output", testing);
   cmd.Parse (argc, argv);
 
   // Distributed simulation setup; by default use granted time window algorithm.
@@ -86,7 +98,12 @@
   // Enable parallel simulator with the command line arguments
   MpiInterface::Enable (&argc, &argv);
 
-  LogComponentEnable ("PacketSink", LOG_LEVEL_INFO);
+  SinkTracer::Init ();
+
+  if (verbose)
+    {
+      LogComponentEnable ("PacketSink", (LogLevel)(LOG_LEVEL_INFO | LOG_PREFIX_NODE | LOG_PREFIX_TIME));
+    }
 
   uint32_t systemId = MpiInterface::GetSystemId ();
   uint32_t systemCount = MpiInterface::GetSize ();
@@ -225,6 +242,7 @@
     }
 
   // Create a packet sink on the right leafs to receive packets from left leafs
+
   uint16_t port = 50000;
   if (systemId == 1)
     {
@@ -234,6 +252,10 @@
       for (uint32_t i = 0; i < 4; ++i)
         {
           sinkApp.Add (sinkHelper.Install (rightLeafNodes.Get (i)));
+          if (testing)
+            {
+              sinkApp.Get (i)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+            }
         }
       sinkApp.Start (Seconds (1.0));
       sinkApp.Stop (Seconds (5));
@@ -263,6 +285,12 @@
   Simulator::Stop (Seconds (5));
   Simulator::Run ();
   Simulator::Destroy ();
+
+  if (testing)
+    {
+      SinkTracer::Verify (4);
+    }
+  
   // Exit the MPI execution environment
   MpiInterface::Disable ();
   return 0;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/mpi/examples/simple-distributed-empty-node.cc ns-3.33/src/mpi/examples/simple-distributed-empty-node.cc
--- ns-3.32/src/mpi/examples/simple-distributed-empty-node.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/mpi/examples/simple-distributed-empty-node.cc	2021-01-09 10:19:22.000000000 -0800
@@ -1,5 +1,7 @@
 /* -*- Mode:C++; c-file-style:"gnu"; indent-tabs-mode:nil; -*- */
 /*
+ *  Copyright 2013. Lawrence Livermore National Security, LLC.
+ *
  * This program is free software; you can redistribute it and/or modify
  * it under the terms of the GNU General Public License version 2 as
  * published by the Free Software Foundation;
@@ -13,6 +15,12 @@
  * along with this program; if not, write to the Free Software
  * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
  *
+ * Author: Steven Smith <smith84@llnl.gov>
+ */
+
+/**
+ * \file
+ * \ingroup mpi
  *
  * This test is equivalent to simple-distributed but tests boundary cases
  * when one of the ranks has no Nodes on it.   When run on two tasks
@@ -56,6 +64,8 @@
  * right leaf nodes output logging information when they receive the packet.
  */
 
+#include "mpi-test-fixtures.h"
+
 #include "ns3/core-module.h"
 #include "ns3/network-module.h"
 #include "ns3/mpi-interface.h"
@@ -66,11 +76,11 @@
 #include "ns3/ipv4-address-helper.h"
 #include "ns3/on-off-helper.h"
 #include "ns3/packet-sink-helper.h"
-#include <mpi.h>
+#include "mpi.h"
 
 using namespace ns3;
 
-NS_LOG_COMPONENT_DEFINE ("SimpleDistributed");
+NS_LOG_COMPONENT_DEFINE ("SimpleDistributedEmptyNode");
 
 int
 main (int argc, char *argv[])
@@ -78,12 +88,16 @@
   bool nix = true;
   bool nullmsg = false;
   bool tracing = false;
+  bool testing = false;
+  bool verbose = false;
 
   // Parse command line
   CommandLine cmd (__FILE__);
   cmd.AddValue ("nix", "Enable the use of nix-vector or global routing", nix);
   cmd.AddValue ("nullmsg", "Enable the use of null-message synchronization", nullmsg);
   cmd.AddValue ("tracing", "Enable pcap tracing", tracing);
+  cmd.AddValue ("verbose", "verbose output", verbose);
+  cmd.AddValue ("test", "Enable regression test output", testing);
   cmd.Parse (argc, argv);
 
   // Distributed simulation setup; by default use granted time window algorithm.
@@ -100,8 +114,13 @@
 
   MpiInterface::Enable (&argc, &argv);
 
-  LogComponentEnable ("PacketSink", LOG_LEVEL_INFO);
-
+  SinkTracer::Init ();
+  
+  if (verbose)
+    {
+      LogComponentEnable ("PacketSink", (LogLevel)(LOG_LEVEL_INFO | LOG_PREFIX_NODE | LOG_PREFIX_TIME));
+    }
+    
   uint32_t systemId = MpiInterface::GetSystemId ();
   uint32_t systemCount = MpiInterface::GetSize ();
 
@@ -258,6 +277,10 @@
       for (uint32_t i = 0; i < 4; ++i)
         {
           sinkApp.Add (sinkHelper.Install (rightLeafNodes.Get (i)));
+          if (testing)
+            {
+              sinkApp.Get (i)->TraceConnectWithoutContext ("RxWithAddresses", MakeCallback (&SinkTracer::SinkTrace));
+            }
         }
       sinkApp.Start (Seconds (1.0));
       sinkApp.Stop (Seconds (5));
@@ -287,6 +310,12 @@
   Simulator::Stop (Seconds (5));
   Simulator::Run ();
   Simulator::Destroy ();
+
+  if (testing)
+    {
+      SinkTracer::Verify (4);
+    }
+  
   // Exit the MPI execution environment
   MpiInterface::Disable ();
   return 0;
